package energycrops;



		import java.sql.*;
	import java.util.*;
	import repast.simphony.engine.environment.RunEnvironment;
import repast.simphony.parameter.Parameters;

	public class Generals extends ProducerAgent{
		
		//private NewVariables newvariables;
		
		Variables Variables;
			
		public Generals(Variables VS){
			Variables = VS;
			//this.newvariables = new NewVariables();
			
		}
				
		public void step1(){
			if(Variables.getyear() == 0){
				//System.out.println("YEAR=0");
				Variables.setrestartmodel(false);
				initialization_phase();
			}
			else{
				//this.newvariables.newvariables();
				simulation_phase();
				//System.out.println("farmerNum:"+Variables.getfarmerlist().size());
			}
		}
		
		public void initialization_phase(){
			
			Parameters p = RunEnvironment.getInstance().getParameters();
			
			int start_run_number = (Integer)p.getValue("startrunnumber");
			int star_sim_scenario = (Integer)p.getValue("starsimscenario");
			int initial_lease_rate = (Integer)p.getValue("initialleaserate");
			int initial_lease_rate_pasture = (Integer)p.getValue("initialleaseratepasture");
			int initial_land_price = (Integer)p.getValue("initiallandprice");
			int initial_land_price_pasture = (Integer)p.getValue("initiallandpricepasture");
				
			
			Variables.setrun_number(Variables.getinitial_run_number());
			Variables.setscenario(star_sim_scenario);
			if(Variables.getyear() == 0 && Variables.getinitial_run_number() == 1) {
				//System.out.println("this is called");
			delet_And_Build_Output_Files();
			}
			set_quality_acres_tenure();
			set_yield_exp();
			set_weighted_avg();
			
		
			Variables.setcropland_price(initial_land_price);
			Variables.setmarginalland_price(initial_land_price_pasture);
			Variables.setcroplease_rate(initial_lease_rate);
			Variables.setmarginallease_rate(initial_lease_rate_pasture);
			 
			 
		}
		
		public void simulation_phase(){
			
			update_parameters();
			update_prices_and_yields();			
			set_yield_exp();
			set_weighted_avg();
		}
		
		  //*******************************  delet_And_Build_Output_Files  ***************************
		  // The following code is to delete the old output tables and build the new output tables
		  // There are four output tables: farmerOut, GlobalOut, ExitOut, and TransferOut.
		 		 		  
		  public void delet_And_Build_Output_Files(){
			  try{
				  Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
			  }catch(ClassNotFoundException ce){
				  System.out.println("SQLExceptiong:"+ce.getMessage());
			  }
			  try{
				  Connection conn=DriverManager.getConnection("jdbc:odbc:producerDB","java","1234");
				  Statement stmt = conn.createStatement();
				  stmt.executeUpdate("drop table GovernmentPayments");
				  stmt.executeUpdate("create table GovernmentPayments (ID int, farmerID int, run_number int, year int, premiums_paid_producer int, premiums_paid_government int, agristability_payments int, agristability_premiums int, total_agriinvest_account_balance int, income_tax int, cropins_payout int, govt_matchagriinvest int, farmer_contribution int, fund_1 int, fund_2 int, eligible_netsales int, crop_sales int, calf_sales int, energycrop_sales int, total_crop_acres int, n_cows double)");
				  stmt.executeUpdate("drop table MIP");
				  stmt.executeUpdate("create table MIP (ID int , farmerID int, run_number int, year int, tillage_fallow int, wheat_on_fallow int, durum_stubble int, canola_stubble int, feed_barley_con int, barley_stubble int, feed_wheat_con int, wheat_stubble int, flax_stubble int, peas_stubble int, feed_barley_notill int, barley_notill int, canola_notill int, feed_wheat_notill int, wheat_notill int, durum_notill int, flax_notill int, lentils_notill int, peas_notill int, willows_on_natural_pasture int, willows_on_improved_pasture int, willows_on_hayland_pasture int, willows_initial_investment int, poplar_on_natural_pasture int, poplar_on_improved_pasture int, poplar_on_hayland_pasture int, poplarinitial_investment int, prairie_sandreed_on_natural_pasture int, prairie_sandreed_on_improved_pasture int, prairie_sandreed_on_hayland_pasture int, prairiesandreed_initial_investment int, natural_pasture int, improved_pasture int, hayland_pasture int, rent_out_cropland int, rent_out_natural_pasture int, rent_out_improved_pasture int, rent_out_hayland_pasture int, pasture_carryover_one int, pasture_carryover_two int, improved_bale_first_cut int, improved_bale_second_cut int, hay_production_one_cut int, hay_production_two_cuts int, breaking_cost int, buy_hay int, buy_feed_wheat int, buy_feed_barley int, feed_early_summer_hay int, feed_late_summer_hay int, feed_fall_hay int, feed_winter_hay int, feed_wheat int, feed_barley int, wheat_straw int, barley_straw int, sell_hay int, invest_cows int, cows_head int, cows_labour int, cows_fc_handling_system int, cows_fc_machinery int, sell_cull_cows int, crop_custom_hire int, option_0_acres int, option_1_acres int, option_2_acres int, option_3_acres int, option_4_acres int, option_5_acres int, option_6_acres int, option_7_acres int, option_8_acres int, option_9_acres int, option_0_number_machines int, option_1_number_machines int, option_2_number_machines int, option_3_number_machines int, option_4_number_machines int, option_5_number_machines int, option_6_number_machines int, option_7_number_machines int, option_8_number_machines int, option_9_number_machines int, rent_pasture_land int, rent_cropland int, amount_borrow int, expected_income int)");
				  stmt.executeUpdate("drop table Tactical");
				  stmt.executeUpdate("create table Tactical (ID int , farmerID int, run_number int, year int, tillage_fallow int, wheat_on_fallow int, durum_stubble int, canola_stubble int, barley_stubble int, wheat_stubble int, flax_stubble int, peas_stubble int, barley_notill int, canola_notill int, wheat_notill int, durum_notill int, flax_notill int, lentils_notill int, peas_notill int, amount_borrow int, expected_income int)");
				  stmt.executeUpdate("drop table Reoptimized");
				  stmt.executeUpdate("create table Reoptimized (ID int , farmerID int, run_number int, year int, tillage_fallow int, wheat_on_fallow int, durum_stubble int, canola_stubble int, feed_barley_con int, barley_stubble int, feed_wheat_con int, wheat_stubble int, flax_stubble int, peas_stubble int, feed_barley_notill int, barley_notill int, canola_notill int, feed_wheat_notill int, wheat_notill int, durum_notill int, flax_notill int, lentils_notill int, peas_notill int, willows_on_natural_pasture int, willows_on_improved_pasture int, willows_on_hayland_pasture int, willows_initial_investment int, poplar_on_natural_pasture int, poplar_on_improved_pasture int, poplar_on_hayland_pasture int, poplarinitial_investment int, prairie_sandreed_on_natural_pasture int, prairie_sandreed_on_improved_pasture int, prairie_sandreed_on_hayland_pasture int, prairiesandreed_initial_investment int, natural_pasture int, improved_pasture int, hayland_pasture int, rent_out_cropland int, rent_out_natural_pasture int, rent_out_improved_pasture int, rent_out_hayland_pasture int, pasture_carryover_one int, pasture_carryover_two int, improved_bale_first_cut int, improved_bale_second_cut int, hay_production_one_cut int, hay_production_two_cuts int, breaking_cost int, buy_hay int, buy_feed_wheat int, buy_feed_barley int, feed_early_summer_hay int, feed_late_summer_hay int, feed_fall_hay int, feed_winter_hay int, feed_wheat int, feed_barley int, wheat_straw int, barley_straw int, sell_hay int, invest_cows int, cows_head int, cows_labour int, cows_fc_handling_system int, cows_fc_machinery int, sell_cull_cows int, crop_custom_hire int, option_0_acres int, option_1_acres int, option_2_acres int, option_3_acres int, option_4_acres int, option_5_acres int, option_6_acres int, option_7_acres int, option_8_acres int, option_9_acres int, option_0_number_machines int, option_1_number_machines int, option_2_number_machines int, option_3_number_machines int, option_4_number_machines int, option_5_number_machines int, option_6_number_machines int, option_7_number_machines int, option_8_number_machines int, option_9_number_machines int, rent_pasture_land int, rent_cropland int, amount_borrow int, expected_income int)");
				  stmt.executeUpdate("drop table Recourse");
				  stmt.executeUpdate("create table Recourse (ID int, farmerID int, run_number int, year int, purchase_hay int, purchase_barley int, earlyhay int, latehay int, fallhay int, winterhay int, winterbarley int, winterwheat int, barleystraw int, wheatstraw int, hayforsale int, barleyforsale int, wheatforsale int, recourse_income int)");
				  stmt.executeUpdate("drop table farmerOut");
				  stmt.executeUpdate("create table farmerOut (ID1 int, farmer_ID int, run_number int, year int, age int, total_acres_farmed int, total_plots_owned int, total_plots_leased int, total_acres_owned int, total_acres_leased int, total_crop_acres int, total_hay int, total_improved_pasture int, total_natural_pasture int, fallow int, wheatfallow int, durumstubble int, canolastubble int, feedbarleycon int, barleystubble int, feedwheatcon int, wheatstubble int, flaxstubble int, peasstubble int, feedwheatnotill int, wheatnotill int, durumnotill int, canolanotill int, feedbarleynotill int, barleynotill int, lentilsnotill int, flaxnotill int, peasnotill int, willowsnaturalpasture int, willowsimprovedpasture int, willowshaylandpasture int, poplarnaturalpasture int, poplarimprovedpasture int, poplarhaylandpasture int, prairiesandreednaturalpasture int, prairiesandreedimprovedpasture int, prairiesandreedhaylandpasture int, debt int, assets int, equity int, cash int, net_worth int, family_living int, ncfbi int, off_farm_inc int, generation int, debt_payment int, lease_pay_crop int, lease_pay_marginal int, land_value int, capital_value int, crop_machine_value int, livestock_equipment_value int, cow_value int, n_cows double, risk_parameter double, crop_machine_age int, total_repairs int, total_gross_crop_inc double, total_net_inc int, gross_hay_income double, gross_income_energycrops double, total_net_energy_income double, total_net_crop_income double, total_net_hay_income double, total_annual_gross_inc double, trucking_distance_energy_crops int, improvedbaleone int, improvedbaletwo int, haybaleone int, haybaletwo int, farmer_type int)");
				  stmt.executeUpdate("drop table GlobalOut");
				  stmt.executeUpdate("create table GlobalOut (ID int, scenario int, run_number int, year int, cropland_price int, marginalland_price int, croplease_rate int, marginallease_rate int, total_farmers int, bankrupt int, cash_flow int, retired int, transfer int, unmanaged int, plots_sold_investor int, plots_sold_farmers int, crop_plots_sold_farmers int, marginal_plots_sold_farmers int)"); 
				  stmt.executeUpdate("drop table ExitOut");
				  stmt.executeUpdate("create table ExitOut (ID int, scenario int, run_number int, year int, who int, why_exit char(10), age int, total_acres_farmed int, total_plots_owned int, total_plots_leased int, total_acres_owned int, total_acres_leased int, total_crop_acres int, debt double, assets int, equity int, cash int, net_worth int, family_living int, ncfbi int, off_farm_inc int, generation int, debt_payment double, land_value int, capital_value int, crop_machine_value int, livestock_equipment_value int, cow_value int, n_cows int, total_hay int, total_improved_pasture int, total_natural_pasture int, fallow int, wheatfallow int, durumstubble int, canolastubble int, feedbarleycon int, barleystubble int, feedwheatcon int, wheatstubble int, flaxstubble int, peasstubble int, feedwheatnotill int, wheatnotill int, durumnotill int, canolanotill int, feedbarleynotill int, barleynotill int, lentilsnotill int, flaxnotill int, peasnotill int, willowsnaturalpasture int, willowsimprovedpasture int, willowshaylandpasture int, poplarnaturalpasture int, poplarimprovedpasture int, poplarhaylandpasture int, prairiesandreednaturalpasture int, prairiesandreedimprovedpasture int, prairiesandreedhaylandpasture int, lease_pay_crop int, lease_pay_marginal int, crop_machine_age int, total_repairs int, total_gross_crop_inc double, total_net_inc int, total_annual_gross_inc double, gross_income_hay double, gross_income_energycrops double, total_net_energy_income double, total_net_crop_income double, total_net_hay_income double, trucking_distance_energy_crops int, improvedbaleone int, improvedbaletwo int, haybaleone int, haybaletwo int)");
				  stmt.executeUpdate("drop table TransferOut");
				  stmt.executeUpdate("create table TransferOut (ID int, run_number int, year int, who int, transfer_value int, transfer_borrow int, age int, total_acres_farmed int, total_plots_owned int, total_plots_leased int, total_acres_owned int, total_acres_leased int, total_crop_acres int, debt double, assets int, equity int, cash int, family_living int, ncfbi int, off_farm_inc int, generation int, debt_payment double, land_value int, capital_value int, risk_parameter double, crop_machine_age int, total_repairs int)");

				  
				  stmt.close();
				  conn.close();
			  }catch(SQLException ce){
				  System.out.println("SQLException:"+ce.getMessage());
			  }
		  }
		
		  //********************************  set_quality_acres_tenure  ****************************
		   // The function is cited by initialization_phase.
		  // The function cites: set_quality_acres_tenure_1 in ABMLand.
		  		
		public void set_quality_acres_tenure(){
			Parameters p = RunEnvironment.getInstance().getParameters();
			int worldXSize = (Integer)p.getValue("worldxsize");
			int worldYSize = (Integer)p.getValue("worldysize");
						
			double mean_patch_q = 0;
			double mean_patch_q_pasture = 0;
			double mean_patch_q_cropland = 0;
			for(int i=0;i<Variables.getlandlist().size();i++){
				SAMA sama = (SAMA) Variables.getlandlist().get(i);
				
					double total_acres_plot = sama.getHay()+ sama.getnp()+ sama.getIP() + sama.getTilled();
					double total_acres_pasture = sama.getHay()+sama.getnp()+sama.getIP();
					//System.out.println("total_pasture" + total_acres_pasture);
					double total_acres_cropland = sama.getTilled();
					//System.out.println("total_acres_plot:" + total_acres_plot);
					sama.setAvg_prod_patch((sama.getIP()*sama.getIPQuality() 
							+ sama.getHay()*sama.getHayQuality()
							+ sama.getnp()*sama.getnpQuality() 
							+ sama.getTilled()*sama.getTilledQuality())/total_acres_plot);
			
					//System.out.println("Patch Id" + sama.getID()+ "Avg_prod_patch="+sama.getAvg_prod_patch());
					sama.setAvg_prod_patch_pasture((sama.getIP()*sama.getIPQuality()+ 
							sama.getHay()*sama.getHayQuality()+
							sama.getnp()*sama.getnpQuality())/total_acres_pasture);
					//System.out.println("Pasture avg prod patch: " + sama.getAvg_prod_patch_pasture());
					sama.setAvg_prod_patch_cropland((sama.getTilled()*sama.getTilledQuality())/total_acres_cropland);
					
				mean_patch_q = mean_patch_q + sama.getAvg_prod_patch();
				mean_patch_q_pasture = mean_patch_q_pasture + sama.getAvg_prod_patch_pasture();
				//System.out.println("avg pasture q:" + mean_patch_q_pasture);
				mean_patch_q_cropland = mean_patch_q_cropland + sama.getAvg_prod_patch_cropland();
			}
			Variables.setmean_patch_quality(mean_patch_q/Variables.getlandlist().size());
			Variables.setmean_patch_quality_pasture(mean_patch_q_pasture/Variables.getlandlist().size());
			Variables.setmean_patch_quality_cropland(mean_patch_q_cropland/Variables.getlandlist().size());
			
			Variables.setall_patches_avg_prod(mean_patch_q/Variables.getlandlist().size());
			
	}
		
			
		  //****************************  set_weighted_avg  ***********************
		  // The function sets up the weighted values in the weighted moving average model which is used to calculate price expectation.
		  // The function is cited by expecation_formulation, set_parameters.
		  		  
		  public void set_weighted_avg(){
			 
			  if(Variables.getyear() > 0){
				  Variables.setlast_year_exp_list(Variables.getexpected_price_list());
			  }
			  
			  double exp_crop_canola = Math.round((5.0/15 * Variables.getlast_5_years_price_canola()[0] + 4.0/15*Variables.getlast_5_years_price_canola()[1] + 3.0/15*Variables.getlast_5_years_price_canola()[2] + 2.0/15*Variables.getlast_5_years_price_canola()[3] + 1.0/15*Variables.getlast_5_years_price_canola()[4])*100.0)/100.0;
			  double exp_crop_wheat = Math.round((5.0/15 * Variables.getlast_5_years_price_wheat()[0] + 4.0/15*Variables.getlast_5_years_price_wheat()[1] + 3.0/15*Variables.getlast_5_years_price_wheat()[2] + 2.0/15*Variables.getlast_5_years_price_wheat()[3] + 1.0/15*Variables.getlast_5_years_price_wheat()[4])*100.0)/100.0;
			  double exp_crop_barley = Math.round((5.0/15 * Variables.getlast_5_years_price_barley()[0] + 4.0/15*Variables.getlast_5_years_price_barley()[1] + 3.0/15*Variables.getlast_5_years_price_barley()[2] + 2.0/15*Variables.getlast_5_years_price_barley()[3] + 1.0/15*Variables.getlast_5_years_price_barley()[4])*100.0)/100.0;
			  double exp_crop_flax = Math.round((5.0/15 * Variables.getlast_5_years_price_flax()[0] + 4.0/15*Variables.getlast_5_years_price_flax()[1] + 3.0/15*Variables.getlast_5_years_price_flax()[2] + 2.0/15*Variables.getlast_5_years_price_flax()[3] + 1.0/15*Variables.getlast_5_years_price_flax()[4])*100.0)/100.0;
			  double exp_crop_peas = Math.round((5.0/15 * Variables.getlast_5_years_price_peas()[0] + 4.0/15*Variables.getlast_5_years_price_peas()[1] + 3.0/15*Variables.getlast_5_years_price_peas()[2] + 2.0/15*Variables.getlast_5_years_price_peas()[3] + 1.0/15*Variables.getlast_5_years_price_peas()[4])*100.0)/100.0;
			  double exp_crop_lentils = Math.round((5.0/15 * Variables.getlast_5_years_price_lentils()[0] + 4.0/15*Variables.getlast_5_years_price_lentils()[1] + 3.0/15*Variables.getlast_5_years_price_lentils()[2] + 2.0/15*Variables.getlast_5_years_price_lentils()[3] + 1.0/15*Variables.getlast_5_years_price_lentils()[4])*100.0)/100.0;
			  double exp_crop_durum = Math.round((5.0/15 * Variables.getlast_5_years_price_durum()[0] + 4.0/15*Variables.getlast_5_years_price_durum()[1] + 3.0/15*Variables.getlast_5_years_price_durum()[2] + 2.0/15*Variables.getlast_5_years_price_durum()[3] + 1.0/15*Variables.getlast_5_years_price_durum()[4])*100.0)/100.0;
			  double exp_hay = Math.round((5.0/15 * Variables.getlast_5_years_price_hay()[0] + 4.0/15 * Variables.getlast_5_years_price_hay()[1] + 3.0/15 * Variables.getlast_5_years_price_hay()[2] +  2.0/15*Variables.getlast_5_years_price_hay()[3] + 1.0/15*Variables.getlast_5_years_price_hay()[4])*100.0)/100.0;
			  double exp_calf_value = Math.round((5.0/15 * Variables.getlast_5_years_price_livestock()[0] + 4.0/15 * Variables.getlast_5_years_price_livestock()[1] + 3.0/15 * Variables.getlast_5_years_price_livestock()[2] +  2.0/15*Variables.getlast_5_years_price_livestock()[3] + 1.0/15*Variables.getlast_5_years_price_livestock()[4])*100.0)/100.0;
			  
			  
			  double[] expected_price_list = new double[] {exp_crop_canola, exp_crop_wheat, exp_crop_barley, exp_calf_value, exp_hay, exp_crop_flax, exp_crop_peas, exp_crop_lentils, exp_crop_durum}; //update this later when have price data
			  Variables.setexpected_price_list(expected_price_list);	
		  }
		  
		  //*********************  set_yield_exp  *********************************
		  // Yield expectation is the moving average of the previous five years, no weighted value and error are considered.
		  // The function is cited by set_parameters and expecation_formulation.
		  
		  public void set_yield_exp(){
			  
			  Parameters p = RunEnvironment.getInstance().getParameters();
			  double pr_max_hay_yield = (Double) p.getValue("prmaxhayyield");
			  
			  double exp_crop_canola = Math.round((Variables.getlast_5_years_yield_canola()[0] + Variables.getlast_5_years_yield_canola()[1] + Variables.getlast_5_years_yield_canola()[2] + Variables.getlast_5_years_yield_canola()[3] + Variables.getlast_5_years_yield_canola()[4])*20.0)/100.0;
			  double exp_crop_wheat = Math.round((Variables.getlast_5_years_yield_wheat()[0] + Variables.getlast_5_years_yield_wheat()[1] + Variables.getlast_5_years_yield_wheat()[2] + Variables.getlast_5_years_yield_wheat()[3] + Variables.getlast_5_years_yield_wheat()[4])*20.0)/100.0;
			  double exp_crop_barley = Math.round((Variables.getlast_5_years_yield_barley()[0] + Variables.getlast_5_years_yield_barley()[1] + Variables.getlast_5_years_yield_barley()[2] + Variables.getlast_5_years_yield_barley()[3] + Variables.getlast_5_years_yield_barley()[4])*20.0)/100.0;
			  double exp_crop_flax = Math.round((Variables.getlast_5_years_yield_flax()[0] + Variables.getlast_5_years_yield_flax()[1] + Variables.getlast_5_years_yield_flax()[2] + Variables.getlast_5_years_yield_flax()[3] + Variables.getlast_5_years_yield_flax()[4])*20.0)/100.0;
			  double exp_crop_peas = Math.round((Variables.getlast_5_years_yield_peas()[0] + Variables.getlast_5_years_yield_peas()[1] + Variables.getlast_5_years_yield_peas()[2] + Variables.getlast_5_years_yield_peas()[3] + Variables.getlast_5_years_yield_peas()[4])*20.0)/100.0;
			  double exp_crop_lentils = Math.round((Variables.getlast_5_years_yield_lentils()[0] + Variables.getlast_5_years_yield_lentils()[1] + Variables.getlast_5_years_yield_lentils()[2] + Variables.getlast_5_years_yield_lentils()[3] + Variables.getlast_5_years_yield_lentils()[4])*20.0)/100.0;
			  double exp_crop_durum = Math.round((Variables.getlast_5_years_yield_durum()[0] + Variables.getlast_5_years_yield_durum()[1] + Variables.getlast_5_years_yield_durum()[2] + Variables.getlast_5_years_yield_durum()[3] + Variables.getlast_5_years_yield_durum()[4])*20.0)/100.0;
				 
			  double exp_crop_hay = Math.round((((Variables.getlast_5_years_yield_hay()[0] + Variables.getlast_5_years_yield_hay()[1] + 
					  Variables.getlast_5_years_yield_hay()[2] + Variables.getlast_5_years_yield_hay()[3] + Variables.getlast_5_years_yield_hay()[4])*20.0)/100.0)* pr_max_hay_yield/50.0);
			 
			  
			  double[] yield_exp_list = new double[] {exp_crop_canola, exp_crop_wheat, exp_crop_barley, exp_crop_hay, exp_crop_flax, exp_crop_peas, exp_crop_lentils, exp_crop_durum}; // Update this later with proper yields
			  
			  Variables.setexpected_yield_list(yield_exp_list);  
		  }	 

		  public void update_parameters(){
			  
			  Parameters p = RunEnvironment.getInstance().getParameters();
			  			  
			  int totalFarmers = (Integer)p.getValue("initialnumberoffarmers");
			  int start_max_distance = (Integer)p.getValue("startmaxdistance");
			  double discount_rate = (Double)p.getValue("discountRate");
			  double interest_rate = (Double)p.getValue("interestRate");
			  
			 Variables.setmax_hay_yield_latepasture(Variables.getmax_hay_yield_earlypasture() *0.3); 
				
			 Variables.setpv_annuity_land((1-(1/Math.pow(1+discount_rate, 20)))/discount_rate);
			 Variables.setyear_20_factor(Math.pow(1+discount_rate, -20));
			 
			 Variables.setloan_factor_payment_20(interest_rate/(1-1/(Math.pow(1+interest_rate, 20))));
			 Variables.setloan_factor_payment_25(interest_rate/(1-1/(Math.pow(1+interest_rate, 25))));
			 Variables.setloan_factor_payment_5(interest_rate/(1-1/(Math.pow(1+interest_rate, 5))));
			 
			 if(Variables.getyear() == 1){
				 Variables.setmax_distance(start_max_distance);
			 }
			 
			  double percent_initial_farmers = Variables.getfarmerlist().size()*1.0 / totalFarmers;

			  int dist_inc = 1;
			  
			  if(percent_initial_farmers < 0.9 && Variables.getmax_distance() == start_max_distance){
				  Variables.setmax_distance(Variables.getmax_distance() + dist_inc);
			  }
			  if(percent_initial_farmers < 0.8 && Variables.getmax_distance() == start_max_distance + dist_inc){
				  Variables.setmax_distance(Variables.getmax_distance() + 2 * dist_inc);
			  }
			  if(percent_initial_farmers < 0.7 && Variables.getmax_distance() == start_max_distance + 2 * dist_inc){
				  Variables.setmax_distance(Variables.getmax_distance() + 3 * dist_inc);
			  }
			  if(percent_initial_farmers < 0.6 && Variables.getmax_distance() == start_max_distance + 3 * dist_inc){
				  Variables.setmax_distance(Variables.getmax_distance() + 4 * dist_inc);
			  }
			  if(percent_initial_farmers < 0.5 && Variables.getmax_distance() == start_max_distance + 4 * dist_inc){
				  Variables.setmax_distance(Variables.getmax_distance() + 5 * dist_inc);
			  }
			  if(percent_initial_farmers < 0.4 && Variables.getmax_distance() == start_max_distance + 5 * dist_inc){
				  Variables.setmax_distance(Variables.getmax_distance() + 6 * dist_inc);
			  }
			  if(percent_initial_farmers < 0.3 && Variables.getmax_distance() == start_max_distance + 6 * dist_inc){
				  Variables.setmax_distance(Variables.getmax_distance() + 7 * dist_inc);
			  }
			  if(percent_initial_farmers < 0.2 && Variables.getmax_distance() == start_max_distance + 7 * dist_inc){
				  Variables.setmax_distance(Variables.getmax_distance() + 8 * dist_inc);
			  }  
			  
		  }

		  public void update_prices_and_yields(){
			  Parameters p = RunEnvironment.getInstance().getParameters();
			  double pr_max_hay_yield = (Double) p.getValue("prmaxhayyield");
			 	
			  Variables.setyield_canola(Variables.getcrop_canola_yield_list()[(Variables.getyear()-1)%30]);
			
			  Variables.setyield_wheat(Variables.getcrop_wheat_yield_list()[(Variables.getyear()-1)%30]);
			  Variables.setyield_durum(Variables.getcrop_durum_yield_list()[(Variables.getyear()-1)%30]);
			  Variables.setyield_barley(Variables.getcrop_barley_yield_list()[(Variables.getyear()-1)%30]);
			  Variables.setyield_flax(Variables.getcrop_flax_yield_list()[(Variables.getyear()-1)%30]);
			  Variables.setyield_peas(Variables.getcrop_peas_yield_list()[(Variables.getyear()-1)%30]);
			  Variables.setyield_lentils(Variables.getcrop_lentils_yield_list()[(Variables.getyear()-1)%30]);
			  Variables.sethay_yield_1(Variables.gethay_yield_list()[(Variables.getyear()-1)%30]);
			  Variables.setmax_hay_yield_earlypasture(Variables.gethay_yield_1()* pr_max_hay_yield/50.0);
			  Variables.setmax_hay_yield_latepasture(0.6*Variables.getmax_hay_yield_earlypasture());
			  Variables.setmax_hay_yield_fall(0.2*Variables.getmax_hay_yield_latepasture());
			 			 
			  Variables.setprice_canola(Variables.getcrop_canola_price_list()[(Variables.getyear()-1)%30]);
			  Variables.setprice_wheat(Variables.getcrop_wheat_price_list()[(Variables.getyear()-1)%30]);
			  Variables.setprice_durum(Variables.getcrop_durum_price_list()[(Variables.getyear()-1)%30]);
			  Variables.setprice_barley(Variables.getcrop_barley_price_list()[(Variables.getyear()-1)%30]);
			  Variables.setprice_flax(Variables.getcrop_flax_price_list()[(Variables.getyear()-1)%30]);
			  Variables.setprice_peas(Variables.getcrop_peas_price_list()[(Variables.getyear()-1)%30]);
			  Variables.setprice_lentils(Variables.getcrop_lentils_price_list()[(Variables.getyear()-1)%30]);
			  Variables.setprice_hay(Variables.gethay_price_list()[(Variables.getyear()-1)%30]);
			  Variables.setprice_calf(Variables.getcalf_price_list()[(Variables.getyear()-1)%30]);
			  
			
			  
			 
			  adjust_price_scenario();
				
			  Variables.setlast_5_years_price_canola(ReNew_5_years_Values(Variables.getlast_5_years_price_canola(),Variables.getprice_canola()));
			  Variables.setlast_5_years_price_wheat(ReNew_5_years_Values(Variables.getlast_5_years_price_wheat(),Variables.getprice_wheat()));
			  Variables.setlast_5_years_price_durum(ReNew_5_years_Values(Variables.getlast_5_years_price_durum(),Variables.getprice_durum()));
			  
			  Variables.setlast_5_years_price_barley(ReNew_5_years_Values(Variables.getlast_5_years_price_barley(),Variables.getprice_barley()));
			  Variables.setlast_5_years_price_flax(ReNew_5_years_Values(Variables.getlast_5_years_price_flax(),Variables.getprice_flax()));
			  Variables.setlast_5_years_price_peas(ReNew_5_years_Values(Variables.getlast_5_years_price_peas(),Variables.getprice_peas()));
			  Variables.setlast_5_years_price_lentils(ReNew_5_years_Values(Variables.getlast_5_years_price_lentils(),Variables.getprice_lentils()));
			  Variables.setlast_5_years_price_hay(ReNew_5_years_Values(Variables.getlast_5_years_price_hay(), Variables.getprice_hay()));
			  Variables.setlast_5_years_price_livestock(ReNew_5_years_Values(Variables.getlast_5_years_price_livestock(), Variables.getprice_calf()));
			  
			  Variables.setlast_5_years_yield_canola(ReNew_5_years_Values(Variables.getlast_5_years_yield_canola(),Variables.getyield_canola()));
			  Variables.setlast_5_years_yield_wheat(ReNew_5_years_Values(Variables.getlast_5_years_yield_wheat(),Variables.getyield_wheat()));
			  Variables.setlast_5_years_yield_durum(ReNew_5_years_Values(Variables.getlast_5_years_yield_durum(),Variables.getyield_durum()));
				 
			  
			  Variables.setlast_5_years_yield_barley(ReNew_5_years_Values(Variables.getlast_5_years_yield_barley(),Variables.getyield_barley()));
			  Variables.setlast_5_years_yield_flax(ReNew_5_years_Values(Variables.getlast_5_years_yield_flax(),Variables.getyield_flax()));
			  Variables.setlast_5_years_yield_peas(ReNew_5_years_Values(Variables.getlast_5_years_yield_peas(),Variables.getyield_peas()));
			  Variables.setlast_5_years_yield_lentils(ReNew_5_years_Values(Variables.getlast_5_years_yield_lentils(),Variables.getyield_lentils()));
			  Variables.setlast_5_years_yield_hay(ReNew_5_years_Values(Variables.getlast_5_years_yield_hay(), Variables.getmax_hay_yield_earlypasture()));
			  
			 // Variables.setlast_5_years_reference_margin(ReNew_5_years_Values(Variables.getlast_5_years_reference_margin(),Variables.getincome_margin()));
		  }
		  
		  //****************************************  adjust_price_scenario  **********************
		  		  
		  public void adjust_price_scenario(){
			  if (Variables.getscenario() == 2){
					Variables.setprice_canola(Variables.getprice_canola() * 1.25);
					Variables.setprice_wheat(Variables.getprice_wheat() * 1.25);
					Variables.setprice_barley(Variables.getprice_barley() * 1.25);
					Variables.setprice_flax(Variables.getprice_flax() * 1.25);
					Variables.setprice_peas(Variables.getprice_peas() * 1.25);
					Variables.setprice_lentils(Variables.getprice_lentils() * 1.25);
			   }	  
			  if (Variables.getscenario() == 3) {
				  Variables.setprice_calf(Variables.getprice_calf() * 1.25);
			  }
		  }

		  //**************************************  ReNew_5_years_Values ************************
		 		  
		  public double[] ReNew_5_years_Values(double[] a, double b){
			  a[4] = a[3]; //4 years ago
			  a[3] = a[2]; //3 years ago
			  a[2] = a[1]; //2 years ago
			  a[1] = a[0]; //last year
			  a[0] = b;    //b is the new value
			  return a;
		  }	  	  
	}



	

