package runmodel;

import java.io.File;

import java.io.File;
import java.util.Iterator;

import energycrops.Generals;
import energycrops.ProducerAgent;

public class Main {
	private Runner runner;
	private int numberOfYears = 31;

	public Main() {
		runner = new Runner();
	}

	public void runStep() {
		File file = new File("energycrops.rs"); // the scenario dir
		try {
			runner.load(file); // load the repast scenario
		} catch (Exception e) {
			e.printStackTrace();
		}
		runner.runInitialize(); // initialize the run

		// RunEnvironment.getInstance().endAt(endTime);
		int i = numberOfYears;
		while (i > 0) { // loop until last action is left
			runner.step(); // execute all scheduled actions at next tick
			i--;
		}

		runner.stop(); // execute any actions scheduled at run end
		runner.cleanUpRun();
		// }
		runner.cleanUpBatch(); // run a
	}

	public static void main(String[] args) {
		for(int i=0; i<100; i++) {
			Main main = new Main();
			main.setNumberOfRuns(i+1);
			
			
					
			

			main.runStep();
		}
	}

	private void setNumberOfRuns(int i) {
		ProducerAgent.setNumberOfRuns(i);
	}
}